# See all tutorials

### Start here

* [Part I - Concrete, Zama's Fully Homomorphic Encryption Compiler](https://www.zama.ai/post/zama-concrete-fully-homomorphic-encryption-compiler)
* [Part II - The Architecture of Concrete, Zama's Fully Homomorphic Encryption Compiler Leveraging MLIR](https://www.zama.ai/post/the-architecture-of-concrete-zama-fully-homomorphic-encryption-compiler-leveraging-mlir)

### Go further

#### Code examples on GitHub

* [Floating points](https://github.com/zama-ai/concrete/blob/release/2.11.X/frontends/concrete-python/examples/floating_point/floating_point.ipynb)
* [Key value database](https://github.com/zama-ai/concrete/blob/release/2.11.X/frontends/concrete-python/examples/key_value_database/key_value_database.ipynb)
* [Game of Life](https://github.com/zama-ai/concrete/blob/release/2.11.X/frontends/concrete-python/examples/game_of_life/README.md)
* [XOR distance](https://github.com/zama-ai/concrete/blob/release/2.11.X/frontends/concrete-python/examples/xor_distance/README.md)
* [SHA1 with Modules](https://github.com/zama-ai/concrete/blob/release/2.11.X/frontends/concrete-python/examples/sha1/README.md)
* [Levenshtein distance with Modules](https://github.com/zama-ai/concrete/blob/release/2.11.X/frontends/concrete-python/examples/levenshtein_distance/README.md)
* [Inventory Matching System](https://github.com/zama-ai/concrete/blob/release/2.11.X/frontends/concrete-python/examples/prime-match/README.md)
* [Private Information Retrieval](https://github.com/zama-ai/concrete/blob/release/2.11.X/frontends/concrete-python/examples/pir/README.md)
* [TFHE-rs Interoperability](https://github.com/zama-ai/concrete/blob/release/2.11.X/frontends/concrete-python/examples/tfhers/README.md)

#### Blog tutorials

* [The Encrypted Game of Life in Python Using Concrete](https://www.zama.ai/post/the-encrypted-game-of-life-using-concrete-python) - November 2023
* [Encrypted Key-value Database Using Homomorphic Encryption](https://www.zama.ai/post/encrypted-key-value-database-using-homomorphic-encryption) - March 2023

#### Video tutorials

* [Compute an XOR distance in FHE using Concrete](https://www.zama.ai/post/video-tutorial-compute-an-xor-distance-in-fhe-using-concrete) - May 2024
* [Speed up neural networks with approximate rounding using Concrete](https://www.zama.ai/post/video-tutorial-speed-up-neural-networks-with-approximate-rounding-using-concrete) - May 2024
* [Compile composable functions with Concrete](https://www.zama.ai/post/video-tutorial-compile-composable-functions-with-concrete) - February 2024
* [How to use dynamic table look-ups using Concrete](https://www.zama.ai/post/video-tutorial-how-to-use-dynamic-table-look-ups-using-concrete) - October 2023
* [Dive into Concrete - Zama's Fully Homomorphic Encryption Compiler](https://www.zama.ai/post/video-tutorial-dive-into-concrete-zamas-fully-homomorphic-encryption-compiler) - October 2023
* [How To Get Started With Concrete - Zama's Fully Homomorphic Encryption Compiler](https://www.zama.ai/post/how-to-started-with-concrete-zama-fully-homomorphic-encryption-compiler) - July 2023


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.zama.org/concrete/tutorials/see-all-tutorials.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
